Std Group: Difference between revisions

From FreeCAD Documentation
(Usage...)
No edit summary
Line 42: Line 42:
<!--T:5-->
<!--T:5-->
# Do one of the following:
# Do one of the following:
#* Right-click the name of the document in the [[Tree_view|Tree view] and in the context menu choose {{MenuCommand|Create group...}}.
#* Right-click the name of the document in the [[Tree_view|Tree view]] and in the context menu choose {{MenuCommand|Create group...}}.
#* Press the {{Button|[[Image:Std_Group.svg|16px]] [[Std_Group|Create group]]}} button.
#* Press the {{Button|[[Image:Std_Group.svg|16px]] [[Std_Group|Create group]]}} button.
# An empty Group is created.
# An empty Group is created.
# To add objects to a Group, select them in [[Tree_view|Tree view]], and then drag and drop them over the Group.
# To add objects to a Group, select them in [[Tree_view|Tree view]], and then drag and drop them onto the Group.
# To remove objects from a Group, drag them out of the Group, and onto the document label at the top of the [[Tree_view|Tree view]].
# To remove objects from a Group, drag them out of the Group, and onto the document label at the top of the [[Tree_view|Tree view]].
# Objects can also be added and removed by editing the {{PropertyData|Group}} property of the Group.
# Objects can also be added and removed by editing the {{PropertyData|Group}} property of the Group.

Revision as of 18:02, 20 February 2022

Std Group

Menu location
Tree view → Right click on the document name → Create group
Workbenches
All
Default shortcut
None
Introduced in version
-
See also
Std Part, Draft SelectGroup, Draft AddToGroup

Description

Std Group (internally called App DocumentObjectGroup) is a general purpose container that allows you to group different types of objects in the tree view, regardless of their data type. It is used as a simple folder to categorize and organize the objects in your model, in order to keep a logical structure. Std Groups may be nested inside other Std Groups.

The Std Group tool is not defined by a particular workbench, but by the base system, thus it is found in the structure toolbar that is available in all workbenches.

To group 3D objects as a single unit, with the intention of creating assemblies, use Std Part instead.

Various elements inside Std Groups in the tree view.

Usage

  1. Do one of the following:
    • Right-click the name of the document in the Tree view and in the context menu choose Create group....
    • Press the Create group button.
  2. An empty Group is created.
  3. To add objects to a Group, select them in Tree view, and then drag and drop them onto the Group.
  4. To remove objects from a Group, drag them out of the Group, and onto the document label at the top of the Tree view.
  5. Objects can also be added and removed by editing the DataGroup property of the Group.

Notes

  • The Group object does not affect the positions in the 3D view of the elements that it contains; it is essentially just a folder that is used to keep the tree view organized.
  • The Group can also be created from the Python console, and sub-classed to create special "groups", as indicated in the Scripting section.

Properties

The Std Group, internally called App DocumentObjectGroup (App::DocumentObjectGroup class), is derived from the basic App DocumentObject (App::DocumentObject class) and inherits all its properties.

The Std Group has the same properties as the App FeaturePython, which is the most basic instance of an App DocumentObject. It also has the following additional properties in the property editor. Hidden properties can be shown by using the Show all command in the context menu of the property editor.

Data

Base

  • DataGroup (LinkList): a list of referenced objects. By default, it is empty [].
  • Data (Hidden)_ Group Touched (Bool): whether the group is touched or not.

Scripting

See also: FreeCAD Scripting Basics and scripted objects.

See Part Feature for the general information on adding objects to the document.

A Std Group (App DocumentObjectGroup) is created with the addObject() method of the document. Once a Group exists, other objects can be added to it with the addObject() or addObjects() methods.

import FreeCAD as App

doc = App.newDocument()
group = App.ActiveDocument.addObject("App::DocumentObjectGroup", "Group")

obj1 = App.ActiveDocument.addObject("PartDesign::Body", "Body")
obj2 = App.ActiveDocument.addObject("Part::Box", "Box")

group.addObjects([obj1, obj2])
App.ActiveDocument.recompute()

This basic App::DocumentObjectGroup doesn't have a Proxy object so it can't be fully used for sub-classing.

For Python subclassing you should create a App::DocumentObjectGroupPython object.

import FreeCAD as App

doc = App.newDocument()
obj = App.ActiveDocument.addObject("App::DocumentObjectGroupPython", "Name")
obj.Label = "Custom label"

For example, a FEM Analysis is an App::DocumentObjectGroupPython object with a custom icon and additional properties.

Links